-- Example use of tightFitText

local tightFitNew = require 'tightFitText'

local DefaultFit = tightFitNew()
local LibSansRegFit = tightFitNew('LiberationSans-Regular.ttf')
local LibMonoRegFit = tightFitNew('LiberationMono-Regular.ttf')

local defaultLoveFont = love.graphics.getFont()

local function getTableCount(t)
  local result = 0
  for k in pairs(t) do
    result = result + 1
  end
  return result
end

function love.draw()
  local width, height = love.graphics.getDimensions()

  love.graphics.rectangle("line", 0.5, 0.5, width-1, height-1)
  LibMonoRegFit:setFittingFont("This is a test", width, height)
  love.graphics.print("This is a test", 0, 0)
  --print(love.graphics.getFont():getWidth("This is a test"))

  love.graphics.rectangle("line", 30.5, 120.5, width*0.75-1, 39)
  DefaultFit:setFittingFont("Hello, world!", width*0.75, 40)
  love.graphics.print("Hello, world!", 30, 120)

  love.graphics.rectangle("line", 20.5, 170.5, width*0.75-1, 139)
  LibSansRegFit:setFittingFont("Hello, world!", width*0.75, 140)
  love.graphics.print("Hello, world!", 20, 170)

  -- The algorithm must calculate at least 1 font + 2 fonts per final size.
  -- Any more fonts are an indication of inefficiency.
  love.graphics.setFont(defaultLoveFont)
  love.graphics.print("Wasted fonts for Liberation Mono Regular: "
    .. tostring(getTableCount(LibMonoRegFit.cacheFont)-3), 0, height-60)
  love.graphics.print("Wasted fonts for Default: "
    .. tostring(getTableCount(DefaultFit.cacheFont)-2), 0, height-40)
  love.graphics.print("Wasted fonts for Liberation Sans Regular: "
    .. tostring(getTableCount(LibSansRegFit.cacheFont)-2), 0, height-20)
end

function love.keypressed(k) return k == "escape" and love.event.quit() end
